/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// 激励メール用FrameSet呼び出し用アクション・クラス
//
//
//	 変更履歴
//		 2004.01.08 新規作成 A.Shimoma
//
package jp.co.ntt.lms.xms.logsumup;

import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.xmo.Lo.LoClient;
import jp.co.ntt.lms.xmo.Mail.MailConst;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsScreenAction;
import jp.co.ntt.lms.xms.framework.XmsSystemException;
import jp.co.ntt.lms.xms.framework.XmsWarningException;
import jp.co.ntt.lms.xms.common.mail.SendUser;
import jp.co.ntt.lms.xms.common.util.CommonUtil;

/**
 * 激励メール用FrameSet呼び出し用アクション・クラス。<br>
 * 
 * @author shimoma
 */
public class LoLogStimMailAction extends XmsScreenAction {



	/**
	 * 初期化処理。<br>
	 * このクラスでfinal宣言しているprocessRequestメソッドの前に実行する。
	 * 空定義しているので、初期化などの処理が必要な場合、
	 * 各サブクラスにて、このメソッドをオーバーライドする。
	 * 
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @exception XmsException
	 */
	protected void initProcessRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {
	}

	/**
	 * アクション実行処理。<br>
	 * 
	 * @exception XmsException
	 */
	protected void processRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {

		try {

			//HttpServletRequestの取得
			HttpServletRequest request = xmsRequest.getRequest();
			LoClient loClient = new LoClient();
			HttpSession session = null;

			// 送信ユーザID,教材ID
			String strUserAndLoList[] = request.getParameterValues( "cheer" );
			// 送信元ID（先生）


			// パラメータチェック
			if (strUserAndLoList.length == 0) {
				throw new XmsInnerException("parameter is null.");
			}

			// メール権限の有無
			boolean usableMail = false;

			SendUser sendUser = new SendUser();

			// メール権限の有無をチェックする
			usableMail = CommonUtil.checkMailAuthority(xmsRequest);
			// メール権限が無い場合はエラー
			if (!usableMail) {
				throw new XmsWarningException("base.w.login.assimnmentsnoroleserror");
			}


			// ユーザID格納リストの生成
			Vector vecUserList = new Vector();
			Vector vctLoList   = new Vector();
		
			if ( strUserAndLoList != null ){
				for ( int i=0; i<strUserAndLoList.length; i++ ){
					int delimt =strUserAndLoList[i].indexOf(',');
					String UserId = strUserAndLoList[i].substring(0, delimt );
					String LoID   = strUserAndLoList[i].substring( delimt+1 );
					vecUserList.add( UserId );
					vctLoList.add( LoID );
				}
			}

			// メール送信１回あたりの送信件数を取得する
			int sendCount = loClient.getSendMailCount();


			// メール送信対象ユーザと教材の設定
			sendUser.setUserAndLo(vecUserList, vctLoList);
			// メール種別の設定
			sendUser.setMailType(Integer.parseInt(MailConst.TYPE_STIMULATE));
			// １回あたりの送信件数を設定
			sendUser.setSendCountMax(sendCount);
			// 画面closeの為のActionID
			sendUser.setCloseActionID("StimMail.close");

			// セッションの取得
			request = xmsRequest.getRequest();
			session = request.getSession(true);
			// 登録ユーザ情報
			session.setAttribute(MailConst.SKEY_SENDUSER, sendUser);
			// メール種別
			session.setAttribute(MailConst.SKEY_MAILTYPE, MailConst.TYPE_STIMULATE);

		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsSystemException(e);
		}

	}

}
